## Xalan-C++ API Documentation

### The Xalan C++ XSLT Processor Version 1.7

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# XPathFunctionTable Class Reference

Class defines a table of functions that can be called in XPath expresions. More...

`#include <XPathFunctionTable.hpp>`

Collaboration diagram for XPathFunctionTable:

List of all members.

## Public Types

- typedef size_t SizeType
- typedef XalanDOMString::size_type StringSizeType
- typedef DeleteFunctor<Function> DeleteFunctorType
- enum {
  InvalidFunctionNumberID = -1,
  TableSize = 36
  }

## Public Methods

- XPathFunctionTable (bool fCreateTable = true)
    Constructor. More...
- ~XPathFunctionTable ()
- void CreateTable ()
    Set up the internal table.
- void DestroyTable ()
    Destroy the internal table.
- const Function& operator[] (const XalanDOMString& theFunctionName) const
    Retrieve the function object for a specified function name. More...
- const Function& operator[] (int theFunctionID) const
    Retrieve the function object for a specified function ID number. More...
- const XalanDOMString idToName (int theFunctionID) const
    Map a function ID to the corresponding name. More...
- int nameToID (const XalanDOMString& theName) const
    Map a function name to the corresponding ID number. More...
- void InstallFunction ( const XalanDOMString& theFunctionName, const Function& theFunction)
    Insert a named function into the function table. More...
- bool UninstallFunction (const XalanDOMString& theFunctionName)
    Remove a named function from the function table. More...
- void InstallFunction ( const XalanDOMChar* theFunctionName, const Function& theFunction)
    Insert a named function into the function table. More...
- bool UninstallFunction (const XalanDOMChar* theFunctionName)
    Remove a named function from the function table. More...
- bool isInstalledFunction (const XalanDOMString& theFunctionName) const
    Whether a named function is in the function table. More...
- template<classOutputIteratorType> void getInstalledFunctionNames (OutputIteratorType theIterator) const
    Add a list of the names of installed functions to a vector of names. More...

## Static Public Attributes

- const XalanDOMChar s_id []
- const XalanDOMChar s_key []
- const XalanDOMChar s_not []
- const XalanDOMChar s_sum []
- const XalanDOMChar s_lang []
- const XalanDOMChar s_last []
- const XalanDOMChar s_name []
- const XalanDOMChar s_true []
- const XalanDOMChar s_count []
- const XalanDOMChar s_false []
- const XalanDOMChar s_floor []
- const XalanDOMChar s_round []
- const XalanDOMChar s_concat []
- const XalanDOMChar s_number []
- const XalanDOMChar s_string []
- const XalanDOMChar s_boolean []
- const XalanDOMChar s_ceiling []
- const XalanDOMChar s_current []
- const XalanDOMChar s_contains []
- const XalanDOMChar s_document []
- const XalanDOMChar s_position []
- const XalanDOMChar s_substring []
- const XalanDOMChar s_translate []
- const XalanDOMChar s_localName []
- const XalanDOMChar s_generateId []
- const XalanDOMChar s_startsWith []
- const XalanDOMChar s_formatNumber []
- const XalanDOMChar s_namespaceUri []
- const XalanDOMChar s_stringLength []
- const XalanDOMChar s_normalizeSpace []
- const XalanDOMChar s_substringAfter []
- const XalanDOMChar s_systemProperty []
- const XalanDOMChar s_substringBefore []
- const XalanDOMChar s_elementAvailable []
- const XalanDOMChar s_functionAvailable []
- const XalanDOMChar s_unparsedEntityUri []
- const FunctionNameTableEntry s_functionNames []
- const SizeType s_functionNamesSize

## Detailed Description

Class defines a table of functions that can be called in XPath expresions.

## Member Typedef Documentation

typedef DeleteFunctor<Function> XPathFunctionTable::DeleteFunctorType

typedef size_t XPathFunctionTable::SizeType

typedef XalanDOMString::size_type XPathFunctionTable::StringSizeType

## Member Enumeration Documentation

anonymous enum

Enumeration values:

  InvalidFunctionNumberID |
  TableSize |

## Constructor & Destructor Documentation

XPathFunctionTable::XPathFunctionTable ( | bool fCreateTable = true )

Constructor.

Parameters:

  fCreateTable | If true, the internal table will be created. Otherwise, CreateTable() must be called.

XPathFunctionTable::~XPathFunctionTable ( | )

## Member Function Documentation

void XPathFunctionTable::CreateTable ( | )

Set up the internal table.

void XPathFunctionTable::DestroyTable ( | )

Destroy the internal table.

void XPathFunctionTable::InstallFunction ( | const XalanDOMChar * theFunctionName,
| const Function & theFunction )

Insert a named function into the function table.

Parameters:

  theFunctionName | name of function
  theFunction | function object corresponding to name

void XPathFunctionTable::InstallFunction ( | const XalanDOMString & theFunctionName,
| const Function & theFunction )`[]`

Insert a named function into the function table.

Parameters:

  theFunctionName | name of function
  theFunction | function object corresponding to name

bool XPathFunctionTable::UninstallFunction ( | const XalanDOMChar * theFunctionName )

Remove a named function from the function table.

Parameters:

  theFunctionName | name of function

Returns:
  true if the function was found and removed.

bool XPathFunctionTable::UninstallFunction ( | const XalanDOMString & theFunctionName )`[]`

Remove a named function from the function table.

Parameters:

  theFunctionName | name of function

Returns:
  true if the function was found and removed.

template<classOutputIteratorType>
void XPathFunctionTable::getInstalledFunctionNames ( | OutputIteratorType theIterator ) const`[]`

Add a list of the names of installed functions to a vector of names.

Parameters:

  theIterator | function table iterator to append names to

const XalanDOMString XPathFunctionTable::idToName ( | int theFunctionID ) const`[]`

Map a function ID to the corresponding name.

Parameters:

  theFunctionID | The ID number of the function

Returns:
  The name of the function, or an empty string if the function doesn't exist.

bool XPathFunctionTable::isInstalledFunction ( | const XalanDOMString & theFunctionName ) const`[]`

Whether a named function is in the function table.

Parameters:

  theFunctionName | name of function

Returns:
  true if function is in table

int XPathFunctionTable::nameToID ( | const XalanDOMString & theName ) const`[]`

Map a function name to the corresponding ID number.

Parameters:

  theName | name of function

Returns:
  The ID number of function, or InvalidFunctionNumberID if the function doesn't exist.

const Function & XPathFunctionTable::operator[] ( | int theFunctionID ) const`[]`

Retrieve the function object for a specified function ID number.

Parameters:

  theFunctionID | ID number of the function

Returns:
  function named

const Function & XPathFunctionTable::operator[] ( | const XalanDOMString & theFunctionName ) const`[]`

Retrieve the function object for a specified function name.

Parameters:

  theFunctionName | name of function

Returns:
  function named

## Member Data Documentation

const XalanDOMChar XPathFunctionTable::s_boolean[]`[static]`

const XalanDOMChar XPathFunctionTable::s_ceiling[]`[static]`

const XalanDOMChar XPathFunctionTable::s_concat[]`[static]`

const XalanDOMChar XPathFunctionTable::s_contains[]`[static]`

const XalanDOMChar XPathFunctionTable::s_count[]`[static]`

const XalanDOMChar XPathFunctionTable::s_current[]`[static]`

const XalanDOMChar XPathFunctionTable::s_document[]`[static]`

const XalanDOMChar XPathFunctionTable::s_elementAvailable[]`[static]`

const XalanDOMChar XPathFunctionTable::s_false[]`[static]`

const XalanDOMChar XPathFunctionTable::s_floor[]`[static]`

const XalanDOMChar XPathFunctionTable::s_formatNumber[]`[static]`

const XalanDOMChar XPathFunctionTable::s_functionAvailable[]`[static]`

const FunctionNameTableEntry XPathFunctionTable::s_functionNames[]`[static]`

const SizeType XPathFunctionTable::s_functionNamesSize`[static]`

const XalanDOMChar XPathFunctionTable::s_generateId[]`[static]`

const XalanDOMChar XPathFunctionTable::s_id[]`[static]`

const XalanDOMChar XPathFunctionTable::s_key[]`[static]`

const XalanDOMChar XPathFunctionTable::s_lang[]`[static]`

const XalanDOMChar XPathFunctionTable::s_last[]`[static]`

const XalanDOMChar XPathFunctionTable::s_localName[]`[static]`

const XalanDOMChar XPathFunctionTable::s_name[]`[static]`

const XalanDOMChar XPathFunctionTable::s_namespaceUri[]`[static]`

const XalanDOMChar XPathFunctionTable::s_normalizeSpace[]`[static]`

const XalanDOMChar XPathFunctionTable::s_not[]`[static]`

const XalanDOMChar XPathFunctionTable::s_number[]`[static]`

const XalanDOMChar XPathFunctionTable::s_position[]`[static]`

const XalanDOMChar XPathFunctionTable::s_round[]`[static]`

const XalanDOMChar XPathFunctionTable::s_startsWith[]`[static]`

const XalanDOMChar XPathFunctionTable::s_string[]`[static]`

const XalanDOMChar XPathFunctionTable::s_stringLength[]`[static]`

const XalanDOMChar XPathFunctionTable::s_substring[]`[static]`

const XalanDOMChar XPathFunctionTable::s_substringAfter[]`[static]`

const XalanDOMChar XPathFunctionTable::s_substringBefore[]`[static]`

const XalanDOMChar XPathFunctionTable::s_sum[]`[static]`

const XalanDOMChar XPathFunctionTable::s_systemProperty[]`[static]`

const XalanDOMChar XPathFunctionTable::s_translate[]`[static]`

const XalanDOMChar XPathFunctionTable::s_true[]`[static]`

const XalanDOMChar XPathFunctionTable::s_unparsedEntityUri[]`[static]`

The documentation for this class was generated from the following file:

- XPathFunctionTable.hpp

Interpreting class diagrams

Doxygen and GraphViz are used to generate this API documentation from the Xalan-C header files.

Xalan-C++ XSLT Processor Version 1.7 Copyright © 1999-2004 The Apache Software Foundation. All Rights Reserved.